(function($,owner){
	owner.me = null;
	owner.version= '0.0.5';
	
	owner.getMe= function(){
		if(owner.me!=null ) return owner.me;
		var u= owner.getState();;
		owner.me={
			"uname":u.userinfo.name,
			"img":u.userinfo.head.s
		}
		//owner.me= owner.getState();

		return owner.me;
	}
	
	owner.getServer= function(){
		if( typeof plus == 'undefined')		return '/pigaimobile/';	
		return 'http://www.pigai.org/';
	}
	owner.showWaiting= function( str ){
		try{
			plus.nativeUI.showWaiting( str);
		}catch(e ){			
		}				
	}
	owner.msgBack = function( str ){
		owner.msg( str);
		var config ={
			url:null
		}
		if( arguments.length>0 ) $.extend( config,arguments[0]);
		setTimeout(function(){
			//owner.closeWaiting();
			if( config.url==null)	$.back();
			else owner.gohref( config.url );
		},1500);
	}
	owner.timenow = function(){
		var timestamp = Date.parse(new Date());
		timestamp = timestamp / 1000;
		return  timestamp;
	}
	owner.doing= function( fun ){
		if( mui.os.plus  ) $.plusReady( fun );
		else fun();
		
	}
	owner.score = function( score ){
		 
		var r={score:0,score_str:'<b class="score_int">0</b>',old:score}
		var score= parseFloat( score );
		if( isNaN( score) || score<0 ) return r;
		 
		var score_int = parseInt( score );
		var score_float = score-score_int;
		score_float = score_float<0.25?0: ( score_float<0.75?0.5:1 );
		if( score_float==1) {
			score_int+=1;
			score_float=0 ; 
		}
		r.score= score_int+score_float;		 
		r.score_str='<b class="score_int">'+score_int+'</b><b class="score_float">'+parseInt(score_float*10)/10+'</b>';
		return r;
		
	}
	owner.href= function(){
		//return true;
		//var main = plus.webview.currentWebview().parent();
		 
		var urlm= this.getAttribute('gohref');
		url_str  = urlm==null? this.getAttribute('href'): urlm;		 
		owner.hrefGoto( url_str);		
		return false; 
	}
	
	owner.hrefGoto = function( url_str){
		if(url_str==undefined || url_str==null ||  url_str=='#'  ) return false;		
		url_str = url_str.trim();
		if(url_str.indexOf('http')==0){
			owner.gohrefHtml( url_str );
			return false ;
		}
		if( arguments.length>1 ){
			owner.gohrefItem( url_str, arguments[1]);
		}else{
			owner.gohrefItem( url_str );
		}
		return true; 
	}
	
	owner.gocache = function(){
		var urlm= this.getAttribute('gohref');
		url_str  = urlm==null? this.getAttribute('href'): urlm;
		if(url_str==undefined || url_str==null ||  url_str=='#'  ) return false;		
		url_str = url_str.trim();
		
		//owner.gohrefItem(url_str,{createNew:false});
		var id= url_str.replace('html/','');
		var wb= plus.webview.getWebviewById(id);
		if(wb!=null){ 
			console.error("cache: "+ url_str );
			wb.show( "flip-rx");
		} else{
			var wb = owner.gohrefItem(url_str ,{id: id});
			cacheWebview( wb );
		} 
	}
	
	var cacheWebview= function( wb ){
		//console.error("cacheCheck webview:"+ wb.id );
		var atime= 10*60*1000; //10分钟检查一次 其实就是缓存10分钟
		function cacheCheck(){
			var cweb= plus.webview.getTopWebview(); 
			//console.error("cacheCheck webview:"+ cweb.id );
			if( cweb.id== wb.id){
				setTimeout(cacheCheck, atime);
			}else{
				console.error("close webview:"+ wb.id +"\t\tnow webview:"+ cweb.id  );
				wb.close();
			}
		}
		setTimeout(cacheCheck, atime);
	}
	
	owner.gohref = function(url ){
		var config={
			'txt':"正确"
			,'auto':false
			,'del':false
			,'close':false 
		}
		if(arguments.length>1) $.extend(config,arguments[1]); 
		var html= '<a class="rprogress" gohref="'+url+'"><span  class="mui-icon iconfont pigai-icon-dui" id="pigai-gohref-href"></span>';
		html+='<div class="rsalert">'+config.txt+'</div></a>';
	    html+='<div class="rprogress-main"></div>';
	    
	    var dv = $('#pigai-gohref-msg');
	    if(  dv.length<=0 ){
		    var d= document.createElement('div');
		    d.id="pigai-gohref-msg";
		    d.innerHTML= html;
		    document.body.appendChild( d );
		}else{
			dv.html( html );
			dv.show();
			 
		}
		$('#pigai-gohref-msg').off('tap','a');
		$('#pigai-gohref-msg').on('tap','a',  (url==undefined || url=='#'|| url=='')?$.back: owner.href );
		
		 
		
		if( config.del==true){		
			$('#pigai-gohref-msg').on('tap','a',  function(){
				var wb = plus.webview.currentWebview();				
				setTimeout( function(){ console.error( wb.getURL());  wb.close(); }, 2000 );
			});
		} 
		
		if( config.auto){
			setTimeout(function(){
				$.trigger(document.getElementById('pigai-gohref-href'),'tap');
			},2000 );
			
		}
	
	}
	
	/**
	 * 
	 * @param {Object} successCB successCallback
	 */
	owner.photoAdd = function( successCB){
		var conf= {
			error:function(){},
			title: "选择照片"
		}
		if( arguments.length>1){
			$.extend( conf,arguments[1]);
		}
		var btnArray = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}];
		plus.nativeUI.actionSheet({
			title: conf.title,
			cancel: "取消",
			buttons: btnArray
		}, function(e) {
			var index = e.index;
			switch (index) {
				case 0:
					break;
				case 1:
					var cmr = plus.camera.getCamera();
					cmr.captureImage(function(path) {							
						successCB( "file://" + plus.io.convertLocalFileSystemURL(path));							
					}, conf.error );
					break;
				case 2:
					plus.gallery.pick(function(path) {							
						successCB(  path );
					}, conf.error , null);
					break;
			}
		});
	}
	/**
	 * @return {Object} obj 
	 * @param {String} str
	 */
	owner.str2obj = function( str ){
		var o = {};
		var arr = str.split("&");
		for(var i=0; i<arr.length; i++){
			var arr2= arr[i].split("=",2);
			o[ arr2[0]]= arr2[1];
		}
		return o;
	}
	owner.gohrefHtml =function(url_str ){
		console.log("httpurl: "+url_str );
		var dv = $('#pigai-gohref-msg');
	    if(  dv.length>0 ){
	    	dv.hide();
	    }
	    var config = {
			id: 'http',
			url: 'http.html?url='+url_str,
			//styles: webview_style,
			show: {
				aniShow: 'pop-in'
			}
			,waiting:{
      			autoShow:true,
      			title:'正在加载...'
			} 
			,createNew:true
			,extras:{
				"httpurl":url_str
			}
		}
		$.openWindow( config );	
		return false; 
	}
	owner.gohrefItem= function(url_str){
		console.log("href:"+url_str );
		var dv = $('#pigai-gohref-msg');
	    if(  dv.length>0 ){
	    	dv.hide();
	    }
		
		 
		var config = {
			id: url_str,
			url: url_str,
			//styles: webview_style,
			show: {
				aniShow: 'pop-in'
			},
			createNew:true,
			waiting: {
				autoShow: false
			},
			extras:{
				
			}
		}
		if(arguments.length>1){
			$.extend( config,arguments[1]);
			console.error( JSON.stringify(arguments[1]));
		}
		return $.openWindow( config );				
	}
	owner.gomain= function(){
		plus.navigator.setStatusBarBackground( '#f7f7f7' );
		$.openWindow({
			id: 'main',
			//"url": '../m.html',
			show: {
				aniShow: 'pop-in'
			},
			waiting: {
				autoShow: false
			}
		});
		return false; 
	}
	owner.getRequest= function() {   
	   var url = location.search; //获取url中"?"符后的字串   
	   var theRequest = new Object();   
	   if (url.indexOf("?") != -1) {   
	      var str = url.substr(1);   
	      strs = str.split("&");   
	      for(var i = 0; i < strs.length; i ++) {   
	         theRequest[strs[i].split("=")[0]]=unescape(strs[i].split("=")[1]);   
	      }   
	   }   
	   return theRequest;   
    } 
    
	owner.ajax = function( d ){
		var config ={
			url:null,
			data:{"abctest":1 },
			success:function(){},
			server:null,
			type:'post'
		}
		$.extend( config,d );
		if( config.url==null ){
			app.log("url error");
			return false;
		}
		//var server = config.server==null ?
		if( config.server=='msg'){
			var server = 'http://msg.pigai.org/tp/';
		}else{
			var server = app.getServer();
		}
		var url = server + config.url;
		url+= (url.indexOf('?')>=0 ? "&":'?')+"pigaimobile=1";
		try{
			var u= app.getState(); 
			//console.log("","aplog",u);
			if( u.minfo!=undefined ){
				url += "&uid="+u.minfo.user_id+"&token="+ u.minfo.pigai_token ;
			}
			
			config.data.MB_time = owner.timenow(); 
			config.data.MB_version= owner.version; 
			config.data.MB_os =  mui.os;
			config.data.MB_uuid= plus.device.uuid;
			var top = plus.webview.getTopWebview();
			config.data.MB_wid= top.id ;
			
			//url+="&MB_uuid="+plus.device.uuid+"&MB_";
		}catch(e){}
		
		app.log(url+ " \npostdata:"+JSON.stringify( config.data));
		//if( url.indexOf())
		 
		 
		$.ajax( url ,{
			data:config.data ,
			dataType:'json',//服务器返回json格式数据
			type: config.type,//HTTP请求类型
			timeout:15000,//超时时间设置为10秒；
			success: function(d){ 
				app.log("\nsuccessful:\n\t"+JSON.stringify( d));  
				if(d.error_des=='token error'){
					nologin();
					return ;
				}
				if( d.error!=undefined && d.error==100300){
					owner.msgBack( d.error_des );
					return ;
				}
				if( d.error!=undefined && d.error==100301 && d.data.url!=undefined ){
					owner.msgBack( d.error_des, d.data );
					return ;
				}
				config.success(d);
				if(d.opt!=undefined && d.opt.js!=undefined ){
					eval( d.opt.js );
				}
			},
			error:function(xhr,type,errorThrown){
				 app.closeWaiting();
				 if(type=='timeout') app.msg( "超时了...");
				 else if( type=='abort') app.msg("连接失败,请检查你的网络");
				 else app.msg( "发生错误！");
				 app.log( type );				  
			}
		});
	}
	function nologin(){
		app.msg("该账号从其他客户端上登录了...");
		//app.log("重新登录...");
		var local = app.get("lguser");
		local.cb= function(){
			$.back();
			app.msg("登录成功");
			//setTimeout( $.back , 1500);			 
		}
		owner.dologin( local );
		
		//setTimeout( function(){ plus.runtime.quit();},1000);
		
	}
	
	/**
	 * 
	 * @param {Function|Array} funArr
	 */
	owner.confirm= function(funArr){
		var conf={
			btn :["确定删除"],				 
			title:"批改网",
			cancel: "取消"
		}
		if(arguments.length>1 ){
			$.extend(conf,arguments[1]);
		}
		var btnArray = new Array();
		for(var i=0; i<conf.btn.length ;i++){
			btnArray.push({'title':conf.btn[i] });
		}
		 
		plus.nativeUI.actionSheet({
			title: conf.title,
			cancel: conf.cancel,
			buttons: btnArray
		}, function(e) {
			var index = e.index;
			if(index <= 0) return true;
			console.error( "select:"+ index );
			if( typeof funArr =='function')funArr();
			else funArr[i-1]();
		});
	}
	
	owner.dologin= function(data){
		 
		var config={
			'account':'',
			'password':'',
			'cb':function () {}
		}
		$.extend( config,data );
		if(config.account==''){
			owner.msg("请填入账号！");
			return false;
		}
		if(config.password  ==''){
			owner.msg("请填入密码！");
			return false;
		} 
		owner.showWaiting( '正在登录...' ) 
		
		 
		owner.ajax({
			data:{'email': config.account,'psw' : config.password },
			url:'?c=api&a=sentbase&action=login&key=SE9mpdwTPxyKGUvJb9vrVfYlwX803YcH&type=json',
			success:function(data){
				
				owner.log( JSON.stringify( data ) );
				owner.closeWaiting();
				if( data.error!=0){					
					owner.msg(  data.error_des );					
					return false; 
				}
				owner.setState(  data.data  );
				config.cb( data.data  );				 
			}
		});	 
		return false; 		
	}
	
	owner.closeWaiting = function(){
		try{
			plus.nativeUI.closeWaiting();			
		}catch(e){
			//TODO handle the exception
		}
		
	}
	owner.registIcomet= function(  config ){
		var url= getServer()+'chat/login.php';
		$.ajax( url ,{
			data:{'uname': config.account  },
			//dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				//owner.log( "请求到达数据："+ data  );
				//owner.setState(  {'uname': cname} );
				plus.nativeUI.closeWaiting();
				owner.msg( '登录成功！');				
				config.cb();
				
				//callback();
			},
			error:function(xhr,type,errorThrown){
				plus.nativeUI.closeWaiting();
				 owner.msg( "发送错误！");
				 owner.log( type );
				  
			}
		});
	}
	
	owner.msg= function(str ){
		try{
			plus.nativeUI.toast( str );
			//plus.nativeUI.toast('再按一次退出应用');
		}catch(e){
			alert(str);
		}
		//console.warn("app-msg："+ str);
		//owner.log(str);
	}
	owner.log= function(  str ){
		try{
		 //console.error("app log:"+ str);
		 console.log( "app log:"+ str );
		}catch(e ){			
		}
		
	}
	
	
	/**
	 * 获取当前状态 
	 **/
	owner.getState = function() {
		
		//var stateText = localStorage.getItem('$state') || "{userinfo:{user_id:0} }";
		var stateText = plus.storage.getItem('$state') || "{userinfo:{user_id:0} }";
		//owner.log(stateText);
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		plus.storage.setItem('$state', JSON.stringify(state));		 
	};
	
	owner.save= function(key,obj){
		obj= obj ||{};	
		plus.storage.setItem( key , JSON.stringify(obj));	
	}
	owner.get= function( key ){
		var str = plus.storage.getItem(key ) || "{}";
		return JSON.parse( str );
	}
	owner.del= function( key ){
		try{
			plus.storage.removeItem( key );
			return true;
		}catch(e){
			return false;
		}
	}

	owner.checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};
	
	owner.backExit = function(){
		var backButtonPress = 0;
		$.back = function(event) {
			backButtonPress++;
			if (backButtonPress > 1) {
				plus.runtime.quit();
			} else {
				plus.nativeUI.toast('再按一次退出应用');
			}
			setTimeout(function() {
				backButtonPress = 0;
			}, 1000);
			return false;
		};
	}
	
	/**
	 * 
	 * @param {String} str
	 * @param {Array} array
	 */
	owner.in_array = function (str, array ){
		for(p in array ){
			if( str == array[p]) return true;
		}
		return false;				
	}
	
	owner.html= function( select){
		var obj= $(select);
		if(obj.length<=0) return false;
		 
	}
	
	owner.listFriend= function(){
		var url= getServer()+'chat/api/contacts.php?type=all';
		var url= getServer()+'tp/chat/user/contacts';
		var config={cb:null };
		var _self = this;
		if(arguments.length>0 ) mui.extend(config,arguments[0]);
		
		$.ajax( url ,{
			data:{},
			dataType:'json',//服务器返回json格式数据
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				//_self.addRen(data);
				console.log(JSON.stringify(data));
				if(config.cb!=null) config.cb( data );
				if( data.error==0 ) owner.save('usersList', data.data.listSave );
				
			},
			error:function(xhr,type,errorThrown){
				 owner.log(type+" url:"+ url);
			}
	    });
	}
	
	/**
	 * @desc	播放http声音，会下载
	 * @param {Object} urlfile
	 * 
	 */
	var player=function(urlfile ){
		var conf={
			type:'mp3',
			start:function( p){   },
			error:function(){},				
			p:null,
			end:function(){},
			savename:null
		}
		if(arguments.length>1 ){
			$.extend( conf,arguments[1] );
		}
		
		savename= conf.savename!=null? conf.savename: urlfile.split('/').pop();
		
		download(urlfile,savename,{
			error:conf.error,
			success:function(){
				var filename = "_downloads/"+savename;
				console.error( "play: "+ filename );
				p = plus.audio.createPlayer(  filename );
				p.play( conf.end,  conf.error ); 
				conf.p= p;	
				conf.start( p ); 
				setTimeout( function(){  console.log("播放时间："+ p.getDuration() ) ; } , 500 ); 
			}
		} ); 
		
	}
	owner.player= player;
	
	/**
	 * 下载 回去检查是否存在文件如果存在 就不下载了
	 * @param {Object} urlfile
	 * @param {Object} filename
	 */
	owner.download = function( urlfile,filename){
		var conf={
			success:function(entry){},
			error:function(e){}
		}
		if(arguments.length>2){
			$.extend(conf,arguments[2]);
		}
		var filename2 = "_downloads/"+filename;
		plus.io.resolveLocalFileSystemURL( filename2 ,conf.success
			,function(){
				var dtask = plus.downloader.createDownload(  urlfile, {'filename': filename2 }, function ( d, status ) {	
					if ( status == 200 ) {
						conf.success( d );
					}else{
						conf.error( d, status);
					}
			 	});
				dtask.start();	
			});			
	}
	var download= owner.download;
	//owner.download = download; 
	
	/**
	 * msg.type =[text|image|sound] 通过这个来表示消息内心
	 * @param {Object} msg
	 */
	owner.sendMsg= function( msg ){
		var url= getServer()+'chat/api/send.php';	
		msg.text= msg.content;
		console.error("sendMsg: "+ JSON.stringify(msg)); 
		$.ajax( url ,{
			data: msg //{	'text':msg.content,		'uid2':msg.uid2			}
			,dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
			},
			error:function(xhr,type,errorThrown){
				//异常处理；
				//if(config.cb!=null) config.cb();
				owner.log("loginerro:"+type+ "\n\nurl:"+ url);
			}
		}); 
		  
		
	}
	
	owner.getUserInfo = function(name){
		
		var u = owner.get( 'usersList');
		console.log(JSON.stringify(u));
		if(u[name]==undefined ) return false;
		return u[name];
	}
	owner._GET= owner.getRequest();
	
}(mui,window.app={} ))
